10 # pkgs parsing utilities
11 PATH=$(dirname $0):$PATH export PATH
15 DEFAULT_PLDISTRO=planetlab
16 DEFAULT_PERSONALITY=linux64
19 COMMAND_VBUILD="vbuild-init-lxc.sh"
20 COMMAND_MYPLC="vtest-init-lxc.sh"
23 lxc_git_repo="git://lxc.git.sourceforge.net/gitroot/lxc/lxc"
25 function bridge_init () {
33 # Default Value for INTERFACE_LAN
34 INTERFACE_LAN=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
37 echo "========== $COMMAND: entering start - beg"
42 echo "========== $COMMAND: entering start - end"
44 # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
46 # another option would be to accept the all forward packages for
47 # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
48 sysctl net.bridge.bridge-nf-call-iptables=0
49 sysctl net.bridge.bridge-nf-call-ip6tables=0
50 sysctl net.bridge.bridge-nf-call-arptables=0
52 # take extra arg for ifname, if provided
53 [ -n "$1" ] && { INTERFACE_LAN=$1; shift ; }
55 #if we have already configured the same host_box no need to do it again
56 /sbin/ifconfig $INTERFACE_BRIDGE &> /dev/null && {
57 echo "Bridge interface $INTERFACE_BRIDGE already set up - $COMMAND start exiting"
60 /sbin/ifconfig $INTERFACE_LAN &>/dev/null || {
61 echo "Cannot use interface $INTERFACE_LAN - exiting"
66 #Getting host IP/masklen
67 address=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
68 [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $INTERFACE_LAN" ; exit 1 ; }
70 broadcast=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
71 [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $INTERFACE_LAN"
73 gateway=$(netstat -rn | grep '^0.0.0.0' | awk '{print $2;}')
74 [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
77 echo "Creating bridge INTERFACE_BRIDGE=$INTERFACE_BRIDGE"
78 brctl addbr $INTERFACE_BRIDGE
79 #brctl stp $INTERFACE_BRIDGE yes
80 brctl addif $INTERFACE_BRIDGE $INTERFACE_LAN
81 echo "Activating promiscuous mode INTERFACE_LAN=$INTERFACE_LAN"
82 /sbin/ifconfig $INTERFACE_LAN 0.0.0.0 promisc up
84 echo "Setting bridge address=$address broadcast=$broadcast"
86 #/sbin/ifconfig $INTERFACE_BRIDGE $address broadcast $broadcast up
87 dhclient $INTERFACE_BRIDGE
90 #Reconfigure the routing table
91 echo "Configuring gateway=$gateway"
92 route add default gw $gateway
94 echo "========== $COMMAND: exiting start - beg"
97 echo "========== $COMMAND: exiting start - end"
105 function failure () {
106 echo "$COMMAND : Bailing out"
110 function cidr_notation () {
114 for i in $(seq 1 4) ; do
115 part=$(echo $netmask | cut -d. -f $i)
117 "255") cidr=$((cidr + 8));;
118 "254") cidr=$((cidr + 7));;
119 "252") cidr=$((cidr + 6));;
120 "248") cidr=$((cidr + 5));;
121 "240") cidr=$((cidr + 4));;
122 "224") cidr=$((cidr + 3));;
123 "192") cidr=$((cidr + 2));;
124 "128") cidr=$((cidr + 1));;
125 "0") cidr=$((cidr + 0));;
132 function check_yum_installed () {
134 rpm -q $package >& /dev/null || yum -y install $package
137 function check_yumgroup_installed () {
139 yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
142 function prepare_host() {
144 #################### lxc-tools : rebuild as current fedora release has flaws
145 #install development tools
146 check_yumgroup_installed "Development Tools"
147 #install libcap-devel, libvirt
148 check_yum_installed libcap-devel
149 check_yum_installed libvirt
151 #retrieve and install lxc from sources
152 raw_version=$(lxc-version ||: )
153 lxc_installed_version=$(echo $raw_version | sed -e 's,.*: ,,')
154 if [ "$lxc_installed_version" != "$lxc_version" ] ; then
155 echo "Expecting version" '['$lxc_version']'
156 echo "Found version" '['$lxc_installed_version']'
157 echo "Installing lxc ..."
159 [ -d lxc ] || git clone "$lxc_git_repo"
162 git checkout $lxc_version
164 ./configure --prefix=/usr --exec-prefix=/usr
167 mkdir -p /usr/var/lib/
168 [ -d /usr/var/lib/lxc ] || ln -s /var/lib/lxc /usr/var/lib/lxc
172 # #create a placeholder (just a hack to make lxc works)
173 # [ -d "/usr/local/var/lib" ] || mkdir -p /usr/local/var/lib
175 #################### bride initialization
176 check_yum_installed bridge-utils
178 isInstalled=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
179 if [ "$isInstalled" != "br0" ] ; then
189 function configure_fedora() {
191 # disable selinux in fedora
192 mkdir -p $rootfs_path/selinux
193 echo 0 > $rootfs_path/selinux/enforce
195 # configure the network
197 cat <<EOF > ${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$IFNAME
211 cat <<EOF > ${rootfs_path}/etc/sysconfig/network
217 # cat <<EOF > $rootfs_path/etc/hosts
218 #127.0.0.1 localhost $HOSTNAME
221 dev_path="${rootfs_path}/dev"
224 mknod -m 666 ${dev_path}/null c 1 3
225 mknod -m 666 ${dev_path}/zero c 1 5
226 mknod -m 666 ${dev_path}/random c 1 8
227 mknod -m 666 ${dev_path}/urandom c 1 9
228 mkdir -m 755 ${dev_path}/pts
229 mkdir -m 1777 ${dev_path}/shm
230 mknod -m 666 ${dev_path}/tty c 5 0
231 mknod -m 666 ${dev_path}/tty0 c 4 0
232 mknod -m 666 ${dev_path}/tty1 c 4 1
233 mknod -m 666 ${dev_path}/tty2 c 4 2
234 mknod -m 666 ${dev_path}/tty3 c 4 3
235 mknod -m 666 ${dev_path}/tty4 c 4 4
236 mknod -m 600 ${dev_path}/console c 5 1
237 mknod -m 666 ${dev_path}/full c 1 7
238 mknod -m 600 ${dev_path}/initctl p
239 mknod -m 666 ${dev_path}/ptmx c 5 2
241 #echo "setting root passwd to $root_password"
242 #echo "root:$root_password" | chroot $rootfs_path chpasswd
248 function configure_fedora_init() {
250 sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
251 sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
252 chroot ${rootfs_path} chkconfig udev-post off
253 chroot ${rootfs_path} chkconfig network on
257 function configure_fedora_systemd() {
259 unlink ${rootfs_path}/etc/systemd/system/default.target
260 touch ${rootfs_path}/etc/fstab
261 chroot ${rootfs_path} ln -s /dev/null //etc/systemd/system/udev.service
262 chroot ${rootfs_path} ln -s /lib/systemd/system/multi-user.target /etc/systemd/system/default.target
263 #dependency on a device unit fails it specially that we disabled udev
264 sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
265 chroot ${rootfs_path} chkconfig network on
268 function download_fedora() {
270 # check the mini fedora was not already downloaded
271 INSTALL_ROOT=$cache/partial
273 mkdir -p $INSTALL_ROOT
274 if [ $? -ne 0 ]; then
275 echo "Failed to create '$INSTALL_ROOT' directory"
279 # download a mini fedora into a cache
280 echo "Downloading fedora minimal ..."
281 YUM="yum --installroot $INSTALL_ROOT -y --nogpgcheck --releasever=$release"
282 PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
285 MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
286 RELEASE_URL="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
287 echo "Fetching from $RELEASE_URL"
288 curl -f "$RELEASE_URL" > $INSTALL_ROOT/fedora-release-$release.noarch.rpm
290 mkdir -p $INSTALL_ROOT/var/lib/rpm
291 rpm --root $INSTALL_ROOT --initdb
292 rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm
293 echo "$YUM install $PKG_LIST"
294 $YUM install $PKG_LIST
296 if [ $? -ne 0 ]; then
297 echo "Failed to download the rootfs, aborting."
301 mv "$INSTALL_ROOT" "$cache/rootfs"
302 echo "Download complete."
308 function copy_fedora() {
310 # make a local copy of the minifedora
311 echo -n "Copying rootfs to $rootfs_path ..."
312 mkdir -p $rootfs_path
313 rsync -a $cache/rootfs/ $rootfs_path/
318 function update_fedora() {
320 YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
325 function install_fedora() {
328 mkdir -p /var/lock/subsys/
331 if [ $? -ne 0 ]; then
332 echo "Cache repository is busy."
336 echo "Checking cache download in $cache/rootfs ... "
337 if [ ! -e "$cache/rootfs" ]; then
339 if [ $? -ne 0 ]; then
340 echo "Failed to download 'fedora base'"
344 echo "Cache found. Updating..."
346 if [ $? -ne 0 ]; then
347 echo "Failed to update 'fedora base', continuing with last known good cache"
349 echo "Update finished"
353 echo "Copy $cache/rootfs to $rootfs_path ... "
355 if [ $? -ne 0 ]; then
356 echo "Failed to copy rootfs"
362 ) 200>/var/lock/subsys/lxc
368 function copy_configuration() {
370 mkdir -p $config_path
371 cat <<EOF >> $config_path/config
376 lxc.rootfs = $rootfs_path
377 lxc.mount = $config_path/fstab
379 lxc.network.type = $lxc_network_type
380 lxc.network.flags = up
381 lxc.network.link = $lxc_network_link
382 lxc.network.name = $IFNAME
383 lxc.network.mtu = 1500
384 lxc.network.ipv4 = $IP/$CIDR
385 lxc.network.veth.pair = $veth_pair
387 #lxc.cgroup.devices.deny = a
389 lxc.cgroup.devices.allow = c 1:3 rwm
390 lxc.cgroup.devices.allow = c 1:5 rwm
392 lxc.cgroup.devices.allow = c 5:1 rwm
393 lxc.cgroup.devices.allow = c 5:0 rwm
394 lxc.cgroup.devices.allow = c 4:0 rwm
395 lxc.cgroup.devices.allow = c 4:1 rwm
397 lxc.cgroup.devices.allow = c 1:9 rwm
398 lxc.cgroup.devices.allow = c 1:8 rwm
399 lxc.cgroup.devices.allow = c 136:* rwm
400 lxc.cgroup.devices.allow = c 5:2 rwm
402 lxc.cgroup.devices.allow = c 254:0 rwm
403 lxc.cgroup.devices.allow = b 255:0 rwm
408 cat <<EOF > $config_path/fstab
409 proc $rootfs_path/proc proc nodev,noexec,nosuid 0 0
410 devpts $rootfs_path/dev/pts devpts defaults 0 0
411 sysfs $rootfs_path/sys sysfs defaults 0 0
413 if [ $? -ne 0 ]; then
414 echo "Failed to add configuration"
424 # overwrite lxc's internal yum config
425 function configure_yum_in_lxc () {
434 echo "Initializing yum.repos.d in $lxc"
435 rm -f $rootfs_path/etc/yum.repos.d/*
437 cat > $rootfs_path/etc/yum.repos.d/building.repo <<EOF
439 name=Fedora $release - \$basearch
440 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/\$basearch/os/
444 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
447 name=Fedora $release - \$basearch - Updates
448 baseurl=http://mirror.onelab.eu/fedora/updates/$release/\$basearch/
452 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
455 # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
456 # just mention 'none' as the repo url
457 if [ -n "$MYPLC_MODE" -a "$REPO_URL" != "none" ] ; then
458 if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
459 echo "WARNING : cannot create myplc repo"
461 # exclude kernel from fedora repos
462 yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
463 for repo in $rootfs_path/etc/yum.repos.d/* ; do
464 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
466 # the build repo is not signed at this stage
467 cat > $rootfs_path/etc/yum.repos.d/myplc.repo <<EOF
478 # return yum or debootstrap
479 function package_method () {
482 f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
483 lenny|etch) echo debootstrap ;;
484 *) echo Unknown distro $fcdistro ;;
488 # return arch from debian distro and personality
489 function canonical_arch () {
490 personality=$1; shift
492 case $(package_method $fcdistro) in
494 case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
496 case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
498 echo Unknown-arch-3 ;;
502 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
503 function almost_empty () {
505 # non existing is fine
506 [ ! -d $dir ] && return 0;
507 # need to have at most one file
508 count=$(cd $dir; ls | wc -l); [ $count -le 1 ];
511 function setup_lxc() {
515 #trap failure ERR INT
520 personality=$1; shift
522 # create lxc container
524 if [ $? -ne 0 ]; then
525 echo "failed write configuration file"
530 if [ $? -ne 0 ]; then
531 echo "failed to install fedora"
536 if [ $? -ne 0 ]; then
537 echo "failed to configure fedora for a container"
541 type /bin/systemd >/dev/null 2>&1
542 if [ $? -ne 0 ]; then
543 configure_fedora_init
545 configure_fedora_systemd
549 mkdir $rootfs_path/cgroup
552 cp /etc/resolv.conf $rootfs_path/etc/resolv.conf
553 # and /etc/hosts for at least localhost
554 [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
557 mkdir $rootfs_path/root/.ssh
558 cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
563 echo $IP is up, waiting for ssh...
565 # wait max 5 min for sshd to start
567 stop_time=$(($(date +%s) + 300))
568 current_time=$(date +%s)
570 while [ "$current_time" -lt "$stop_time" ] ; do
571 echo "ssh attempt ..."
572 ssh -o "StrictHostKeyChecking no" $IP 'uname -i' && { ssh_up=true; echo "SSHD in container $lxc is UP"; break ; } || :
574 current_time=$(($current_time + 10))
577 [ -z $ssh_up ] && echo "SSHD in container $lxc is not running"
581 chroot $rootfs_path rpm --rebuilddb
582 #ssh -o "StrictHostKeyChecking no" $IP "rpm --rebuilddb"
584 configure_yum_in_lxc $lxc $fcdistro $pldistro
589 function devel_or_vtest_tools () {
598 personality=$1; shift
600 pkg_method=$(package_method $fcdistro)
602 # check for .pkgs file based on pldistro
603 if [ -n "$VBUILD_MODE" ] ; then
608 pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $pkgsname)
610 ### install individual packages, then groups
611 # get target arch - use uname -i here (we want either x86_64 or i386)
613 lxc_arch=$(chroot $rootfs_path uname -i)
614 # on debian systems we get arch through the 'arch' command
615 [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path arch)
617 packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
618 groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
620 case "$pkg_method" in
622 [ -n "$packages" ] && chroot $rootfs_path yum -y install $packages
623 for group_plus in $groups; do
624 group=$(echo $group_plus | sed -e "s,+++, ,g")
625 chroot $rootfs_path yum -y groupinstall "$group"
627 # store current rpm list in /init-lxc.rpms in case we need to check the contents
628 chroot $rootfs_path rpm -aq > $rootfs_path/init-lxc.rpms
631 chroot $rootfs_path apt-get update
632 for package in $packages ; do
633 chroot $rootfs_path apt-get install -y $package
635 ### xxx todo install groups with apt..
638 echo "unknown pkg_method $pkg_method"
645 function post_install () {
646 if [ -n "$VBUILD_MODE" ] ; then
647 post_install_vbuild "$@"
649 post_install_myplc "$@"
651 # setup localtime from the host
653 cp /etc/localtime $rootfs_path/etc/localtime
656 function post_install_vbuild () {
663 personality=$1; shift
665 ### From myplc-devel-native.spec
666 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
667 cat << EOF | chroot $rootfs_path bash -x
668 # set up /dev/loop* in lxc
669 for i in \$(seq 0 255) ; do
670 mknod -m 640 /dev/loop\$i b 7 \$i
673 # create symlink for /dev/fd
674 [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
676 # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
677 sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
678 if [ -h "/sbin/new-kernel-pkg" ] ; then
679 filename=\$(readlink -f /sbin/new-kernel-pkg)
680 if [ "\$filename" == "/sbin/true" ] ; then
681 echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
682 echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
683 echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
688 # customize root's prompt
689 cat << PROFILE > /root/.profile
690 export PS1="[$lxc] \\w # "
696 # add a "build" user to the system
697 builduser=\$(grep "^build:" /etc/passwd | wc -l)
698 if [ \$builduser -eq 0 ] ; then
699 groupadd -o -g \$gid build;
700 useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
703 # Allow build user to build certain RPMs as root
704 if [ -f /etc/sudoers ] ; then
705 buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL" /etc/sudoers | wc -l)
706 if [ \$buildsudo -eq 0 ] ; then
707 echo "build ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
709 sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
716 function post_install_myplc () {
722 personality=$1; shift
724 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
725 cat << EOF | chroot $rootfs_path bash -x
727 # create /etc/sysconfig/network if missing
728 [ -f /etc/sysconfig/network ] || echo NETWORKING=yes > /etc/sysconfig/network
730 # create symlink for /dev/fd
731 [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
733 # turn off regular crond, as plc invokes plc_crond
736 # take care of loginuid in /etc/pam.d
737 sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
739 # customize root's prompt
740 cat << PROFILE > /root/.profile
741 export PS1="[$lxc] \\w # "
749 echo "Usage: $COMMAND_VBUILD [options] lxc-name"
750 echo "Usage: $COMMAND_MYPLC [options] lxc-name repo-url [ -- lxc-options ]"
752 echo " This command creates a fresh lxc instance, for building, or running, myplc"
753 echo "Supported options"
754 echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
755 echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
756 echo " -p personality - defaults to $DEFAULT_PERSONALITY"
757 echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the lxc"
758 echo "-- lxc-options"
759 echo " --netdev : interface to be defined inside lxc"
760 echo " --interface : IP to be defined for the lxc"
761 echo " --hostname : Hostname to be defined for the lxc"
762 echo "With $COMMAND_MYPLC you can give 'none' as the URL, in which case"
763 echo " myplc.repo does not get created"
771 #trap failure ERR INT
786 while getopts "f:d:p:i:" opt ; do
788 f) fcdistro=$OPTARG;;
789 d) pldistro=$OPTARG;;
790 p) personality=$OPTARG;;
796 shift $(($OPTIND - 1))
798 # parse fixed arguments
799 [[ -z "$@" ]] && usage
801 if [ -n "$MYPLC_MODE" ] ; then
802 [[ -z "$@" ]] && usage
806 # parse vserver options
807 if [[ -n "$@" ]] ; then
808 if [ "$1" == "--" ] ; then
816 eval set -- "$LXC_OPTIONS"
821 --netdev) IFNAME=$2; shift 2;;
822 --interface) IP=$2; shift 2;;
823 --hostname) HOSTNAME=$2; shift 2;;
829 if [ -n "$VBUILD_MODE" ] ; then
830 [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
831 [ -z "$HOSTNAME" ] && HOSTNAME=$lxc
834 [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
835 [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
836 [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
838 release=$(echo $fcdistro | cut -df -f2)
840 if [ "$personality" == "linux32" ]; then
843 elif [ "$personality" == "linux64" ]; then
847 echo "Unknown personality: $personality"
850 # need lxc installed before we can run lxc-ls
851 # need bridge installed
854 if [ -n "$VBUILD_MODE" ] ; then
856 # Bridge IP affectation
857 x=$(echo $personality | cut -dx -f2)
858 y=$(echo $fcdistro | cut -df -f2)
862 NETMASK="255.255.255.0"
863 GATEWAY="192.168.122.1"
865 lxc_network_type=veth
866 lxc_network_link=virbr0
868 echo "the IP address of container $lxc is $IP "
870 [[ -z "$REPO_URL" ]] && usage
871 [[ -z "$IP" ]] && usage
872 NETMASK=$(ifconfig br0 | grep 'inet addr' | awk '{print $4}' | sed -e 's/.*://')
873 GATEWAY=$(route -n | grep 'UG' | awk '{print $2}')
874 [[ -z "$HOSTNAME" ]] && usage
875 lxc_network_type=veth
877 veth_pair="i$(echo $HOSTNAME | cut -d. -f1)"
880 CIDR=$(cidr_notation $NETMASK)
883 if [ "$(id -u)" != "0" ]; then
884 echo "This script should be run as 'root'"
889 rootfs_path=$path/$lxc/rootfs
890 config_path=$path/$lxc
891 cache_base=/var/cache/lxc/fedora/$arch
892 cache=$cache_base/$release
895 # check whether the rootfs directory is created to know if the container exists
896 # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
897 [ -d $rootfs_path ] && { echo "container $lxc already exists - exiting" ; exit 1 ; }
899 setup_lxc $lxc $fcdistro $pldistro $personality
901 devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
903 post_install $lxc $personality